Index: code/trunk/src/core/input/KeyBinder.h
===================================================================
--- code/trunk/src/core/input/KeyBinder.h	(revision 1881)
+++ code/trunk/src/core/input/KeyBinder.h	(revision 1887)
@@ -39,9 +39,9 @@
 
 #include <vector>
-
-#include "core/OrxonoxClass.h"
 #include "InputInterfaces.h"
 #include "Button.h"
 #include "HalfAxis.h"
+#include "InputCommands.h"
+#include "JoyStickDeviceNumberListener.h"
 
 namespace orxonox
@@ -52,5 +52,6 @@
         Manages the key bindings.
     */
-    class _CoreExport KeyBinder : public KeyHandler, public MouseHandler, public JoyStickHandler, public OrxonoxClass
+    class _CoreExport KeyBinder : public KeyHandler, public MouseHandler, public JoyStickHandler,
+                                  public JoyStickDeviceNumberListener
     {
     public:
@@ -58,6 +59,7 @@
         virtual ~KeyBinder();
 
-        void loadBindings();
+        void loadBindings(const std::string& filename);
         void clearBindings();
+        bool setBinding(const std::string& binding, const std::string& name, bool bTemporary = false);
         void setConfigValues();
         void resetJoyStickAxes();
@@ -65,11 +67,15 @@
     protected: // functions
         void tickInput(float dt);
-        //void tickInput(float dt, int device);
         void tickKey(float dt) { }
         void tickMouse(float dt);
         void tickJoyStick(float dt, unsigned int joyStick);
-        void tickDevices(unsigned int begin, unsigned int end);
-
-        virtual void readTrigger(Button& button);
+        // internal
+        void tickDevices(HalfAxis* begin, HalfAxis* end);
+
+        void buttonThresholdChanged();
+        // from JoyStickDeviceNumberListener interface
+        virtual void JoyStickDeviceNumberChanged(unsigned int value);
+        void initialiseJoyStickBindings();
+        void compilePointerLists();
 
         void keyPressed (const KeyEvent& evt);
@@ -77,44 +83,49 @@
         void keyHeld    (const KeyEvent& evt);
 
-        void mouseButtonPressed (MouseButton::Enum id);
-        void mouseButtonReleased(MouseButton::Enum id);
-        void mouseButtonHeld    (MouseButton::Enum id);
+        void mouseButtonPressed (MouseButtonCode::ByEnum id);
+        void mouseButtonReleased(MouseButtonCode::ByEnum id);
+        void mouseButtonHeld    (MouseButtonCode::ByEnum id);
         void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize);
         void mouseScrolled      (int abs, int rel);
 
-        void joyStickButtonPressed (unsigned int joyStickID, JoyStickButton::Enum id);
-        void joyStickButtonReleased(unsigned int joyStickID, JoyStickButton::Enum id);
-        void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButton::Enum id);
+        void joyStickButtonPressed (unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
+        void joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
+        void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
         void joyStickAxisMoved     (unsigned int joyStickID, unsigned int axis, float value);
 
     protected: // variables
-        //! denotes the number of different keys there are in OIS.
-        static const unsigned int nKeys_s = 0xEE;
-        //! Actual key bindings as bundle for Press, Hold and Release
-        Button keys_ [nKeys_s];
-
-        //! denotes the number of different mouse buttons there are in OIS.
-        static const unsigned int nMouseButtons_s = 8 + 2*2; // 8 buttons and 2 scroll wheels
-        //! Actual key bindings as bundle for Press, Hold and Release
-        Button mouseButtons_ [nMouseButtons_s];
-
-        //! denotes the number of different joy stick buttons there are in OIS.
-        static const unsigned int nJoyStickButtons_s = 32 + 4 * 4; // 32 buttons and 4 POVs with 4 buttons
-        //! Actual key bindings as bundle for Press, Hold and Release
-        Button joyStickButtons_ [nJoyStickButtons_s];
-
-        //! denotes the number of half axes (every axis twice) there can be.
-        static const unsigned int nHalfAxes_s = 56;
-        /**
-        * Array with all the half axes for mouse and joy sticks.
-        * Keep in mind that the positions are fixed and that the first entry is the
-        * positive one and the second is negative.
-        * Sequence is as follows:
-        *  0 -  3: Mouse x and y
-        *  4 -  7: empty
-        *  8 - 23: joy stick slider axes 1 to 8
-        * 24 - 55: joy stick axes 1 - 16
-        */
-        HalfAxis halfAxes_[nHalfAxes_s];
+        //! Currently active joy sticks
+        unsigned int numberOfJoySticks_;
+
+        //! Actual key bindings for keys on the keyboard
+        Button keys_            [KeyCode::numberOfKeys];
+        //! Number of mouse buttons in KeyBinder (+4)
+        static const int numberOfMouseButtons_ = MouseButtonCode::numberOfButtons + 4;
+        //! Actual key bindings for mouse buttons including the wheel(s)
+        Button mouseButtons_    [numberOfMouseButtons_];
+        //! Actual key bindings for mouse axes
+        HalfAxis mouseAxes_     [MouseAxisCode::numberOfAxes * 2];
+
+        //! Helper class to use something like std:vector<Button[64]>
+        struct JoyStickButtonVector
+        {
+            Button& operator[](unsigned int index) { return buttons[index]; }
+            Button buttons[JoyStickButtonCode::numberOfButtons];
+        };
+        //! Actual key bindings for joy stick buttons
+        std::vector<JoyStickButtonVector> joyStickButtons_;
+        //! Helper class to use something like std:vector<HalfAxis[48]>
+        struct JoyStickAxisVector
+        {
+            HalfAxis& operator[](unsigned int index) { return halfAxes[index]; }
+            HalfAxis halfAxes[JoyStickAxisCode::numberOfAxes * 2];
+        };
+        //! Actual key bindings for joy stick axes (and sliders)
+        std::vector<JoyStickAxisVector> joyStickAxes_;
+
+        //! Pointer map with all Buttons, including half axes
+        std::map<std::string, Button*> allButtons_;
+        //! Pointer list with all half axes
+        std::vector<HalfAxis*> allHalfAxes_;
 
         /**
@@ -131,7 +142,11 @@
         float deriveTime_;
 
-
+        //! Config file used. "" in case of KeyDetector. Also indicates whether we've already loaded.
+        std::string configFile_;
+
+    private:
         //##### ConfigValues #####
-
+        //! Filename of default keybindings.
+        std::string defaultKeybindings_;
         //! Threshold for analog triggers until which the state is 0.
         float analogThreshold_;
@@ -146,7 +161,56 @@
         //! mouse sensitivity if mouse input is derived
         float mouseSensitivityDerived_;
-        //! Whether or not to clip abslute mouse values to 1024
-        bool bClipMouse_;
+        //! Equals one step of the mousewheel
+        float mouseWheelStepSize_;
+
+        //##### Constant config variables #####
+        // Use some value at about 1000. This can be configured with mouseSensitivity_ anyway.
+        static const int mouseClippingSize_ = 1024;
     };
+
+    inline void KeyBinder::keyPressed (const KeyEvent& evt)
+    { keys_[evt.key].execute(KeybindMode::OnPress); }
+
+    inline void KeyBinder::keyReleased(const KeyEvent& evt)
+    { keys_[evt.key].execute(KeybindMode::OnRelease); }
+
+    inline void KeyBinder::keyHeld    (const KeyEvent& evt)
+    { keys_[evt.key].execute(KeybindMode::OnHold); }
+
+
+    inline void KeyBinder::mouseButtonPressed (MouseButtonCode::ByEnum id)
+    { mouseButtons_[id].execute(KeybindMode::OnPress); }
+
+    inline void KeyBinder::mouseButtonReleased(MouseButtonCode::ByEnum id)
+    { mouseButtons_[id].execute(KeybindMode::OnRelease); }
+
+    inline void KeyBinder::mouseButtonHeld    (MouseButtonCode::ByEnum id)
+    { mouseButtons_[id].execute(KeybindMode::OnHold); }
+
+
+    inline void KeyBinder::joyStickButtonPressed (unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
+    { joyStickButtons_[joyStickID][id].execute(KeybindMode::OnPress); }
+
+    inline void KeyBinder::joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
+    { joyStickButtons_[joyStickID][id].execute(KeybindMode::OnRelease); }
+
+    inline void KeyBinder::joyStickButtonHeld    (unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
+    { joyStickButtons_[joyStickID][id].execute(KeybindMode::OnHold); }
+
+    inline void KeyBinder::tickJoyStick(float dt, unsigned int joyStick)
+    {
+        tickDevices(&joyStickAxes_[joyStick][0], &joyStickAxes_[joyStick][JoyStickAxisCode::numberOfAxes * 2]);
+    }
+
+    inline void KeyBinder::tickInput(float dt)
+    {
+        // execute all buffered bindings (additional parameter)
+        for (unsigned int i = 0; i < paramCommandBuffer_.size(); i++)
+            paramCommandBuffer_[i]->execute();
+
+        // always reset the relative movement of the mouse
+        for (unsigned int i = 0; i < MouseAxisCode::numberOfAxes * 2; i++)
+            mouseAxes_[i].relVal_ = 0.0f;
+    }
 }
 
Index: code/trunk/src/core/input/KeyDetector.cc
===================================================================
--- code/trunk/src/core/input/KeyDetector.cc	(revision 1881)
+++ code/trunk/src/core/input/KeyDetector.cc	(revision 1887)
@@ -62,22 +62,21 @@
     /**
     @brief
-        Loads the key and button bindings.
-    @return
-        True if loading succeeded.
+        Assigns all the buttons 'command' plus the button's name.
     */
-    void KeyDetector::loadBindings(const std::string& command)
+    void KeyDetector::setCallbackCommand(const std::string& command)
     {
-        this->command_ = command;
+        callbackCommand_ = command;
         clearBindings();
-        setConfigValues();
+        for (std::map<std::string, Button*>::const_iterator it = allButtons_.begin(); it != allButtons_.end(); ++it)
+        {
+            it->second->bindingString_ = callbackCommand_ + it->second->name_;
+            it->second->parse();
+        }
     }
 
-    void KeyDetector::readTrigger(Button& button)
+    void KeyDetector::JoyStickDeviceNumberChanged(unsigned int value)
     {
-        SimpleCommand* cmd = new SimpleCommand();
-        cmd->evaluation_ = CommandExecutor::evaluate(this->command_ + " " + button.name_);
-        button.commands_[KeybindMode::OnPress] = new BaseCommand*[1];
-        button.commands_[KeybindMode::OnPress][0] = cmd;
-        button.nCommands_[KeybindMode::OnPress] = 1;
+        KeyBinder::JoyStickDeviceNumberChanged(value);
+        setCallbackCommand(callbackCommand_);
     }
 }
Index: code/trunk/src/core/input/KeyDetector.h
===================================================================
--- code/trunk/src/core/input/KeyDetector.h	(revision 1881)
+++ code/trunk/src/core/input/KeyDetector.h	(revision 1887)
@@ -47,11 +47,9 @@
         KeyDetector();
         ~KeyDetector();
-        void loadBindings(const std::string& command);
-
-    protected:
-        void readTrigger(Button& button);
+        void setCallbackCommand(const std::string& command);
+        void JoyStickDeviceNumberChanged(unsigned int value);
 
     private:
-        std::string command_;
+        std::string callbackCommand_;
     };
 }
Index: code/trunk/src/core/input/SimpleInputState.cc
===================================================================
--- code/trunk/src/core/input/SimpleInputState.cc	(revision 1881)
+++ code/trunk/src/core/input/SimpleInputState.cc	(revision 1887)
@@ -35,12 +35,6 @@
 #include "SimpleInputState.h"
 
-#include <assert.h>
-#include "util/Debug.h"
-#include "core/Executor.h"
-
 namespace orxonox
 {
-    using namespace InputDevice;
-
     SimpleInputState::SimpleInputState()
         : keyHandler_(0)
@@ -70,76 +64,4 @@
         if (keyHandler_)
             keyHandler_->keyPressed(evt);
-    }
-
-    void SimpleInputState::keyReleased(const KeyEvent& evt)
-    {
-        if (keyHandler_)
-            keyHandler_->keyReleased(evt);
-    }
-
-    void SimpleInputState::keyHeld(const KeyEvent& evt)
-    {
-        if (keyHandler_)
-            keyHandler_->keyHeld(evt);
-    }
-
-
-    void SimpleInputState::mouseMoved(IntVector2 abs, IntVector2 rel, IntVector2 clippingSize)
-    {
-        if (mouseHandler_)
-            mouseHandler_->mouseMoved(abs, rel, clippingSize);
-    }
-
-    void SimpleInputState::mouseScrolled(int abs, int rel)
-    {
-        if (mouseHandler_)
-            mouseHandler_->mouseScrolled(abs, rel);
-    }
-
-    void SimpleInputState::mouseButtonPressed(MouseButton::Enum id)
-    {
-        if (mouseHandler_)
-            mouseHandler_->mouseButtonPressed(id);
-    }
-
-    void SimpleInputState::mouseButtonReleased(MouseButton::Enum id)
-    {
-        if (mouseHandler_)
-            mouseHandler_->mouseButtonReleased(id);
-    }
-
-    void SimpleInputState::mouseButtonHeld(MouseButton::Enum id)
-    {
-        if (mouseHandler_)
-            mouseHandler_->mouseButtonHeld(id);
-    }
-
-
-    void SimpleInputState::joyStickAxisMoved(unsigned int joyStickID, unsigned int axis, float value)
-    {
-        assert(joyStickID < joyStickHandler_.size());
-        if (joyStickHandler_[joyStickID])
-            joyStickHandler_[joyStickID]->joyStickAxisMoved(joyStickID, axis, value);
-    }
-
-    void SimpleInputState::joyStickButtonPressed(unsigned int joyStickID, JoyStickButton::Enum id)
-    {
-        assert(joyStickID < joyStickHandler_.size());
-        if (joyStickHandler_[joyStickID])
-            joyStickHandler_[joyStickID]->joyStickButtonPressed(joyStickID, id);
-    }
-
-    void SimpleInputState::joyStickButtonReleased(unsigned int joyStickID, JoyStickButton::Enum id)
-    {
-        assert(joyStickID < joyStickHandler_.size());
-        if (joyStickHandler_[joyStickID])
-            joyStickHandler_[joyStickID]->joyStickButtonReleased(joyStickID, id);
-    }
-
-    void SimpleInputState::joyStickButtonHeld(unsigned int joyStickID, JoyStickButton::Enum id)
-    {
-        assert(joyStickID < joyStickHandler_.size());
-        if (joyStickHandler_[joyStickID])
-            joyStickHandler_[joyStickID]->joyStickButtonHeld(joyStickID, id);
     }
 
@@ -199,33 +121,4 @@
     }
 
-    void SimpleInputState::tickInput(float dt)
-    {
-        for (unsigned int i = 0; i < allHandlers_.size(); ++i)
-        {
-            allHandlers_[i]->tickInput(dt);
-        }
-    }
-
-    void SimpleInputState::tickInput(float dt, unsigned int device)
-    {
-        switch (device)
-        {
-        case Keyboard:
-            if (keyHandler_)
-                keyHandler_->tickKey(dt);
-            break;
-
-        case Mouse:
-            if (mouseHandler_)
-                mouseHandler_->tickMouse(dt);
-            break;
-
-        default: // joy sticks
-            if (joyStickHandler_[device - 2])
-                joyStickHandler_[device - 2]->tickJoyStick(dt, device - 2);
-            break;
-        }
-    }
-
     void SimpleInputState::update()
     {
@@ -247,6 +140,6 @@
 
         // update the deviceEnabled options
-        setInputDeviceEnabled(Keyboard, (keyHandler_ != 0));
-        setInputDeviceEnabled(Mouse, (mouseHandler_ != 0));
+        setInputDeviceEnabled(InputDevice::Keyboard, (keyHandler_ != 0));
+        setInputDeviceEnabled(InputDevice::Mouse, (mouseHandler_ != 0));
         for (unsigned int i = 0; i < joyStickHandler_.size(); ++i)
             setInputDeviceEnabled(2 + i, (joyStickHandler_[i] != 0));
Index: code/trunk/src/core/input/SimpleInputState.h
===================================================================
--- code/trunk/src/core/input/SimpleInputState.h	(revision 1881)
+++ code/trunk/src/core/input/SimpleInputState.h	(revision 1887)
@@ -38,4 +38,5 @@
 
 #include <vector>
+#include <cassert>
 #include "InputInterfaces.h"
 #include "InputState.h"
@@ -65,13 +66,13 @@
         void keyHeld    (const KeyEvent& evt);
 
-        void mouseButtonPressed (MouseButton::Enum id);
-        void mouseButtonReleased(MouseButton::Enum id);
-        void mouseButtonHeld    (MouseButton::Enum id);
+        void mouseButtonPressed (MouseButtonCode::ByEnum id);
+        void mouseButtonReleased(MouseButtonCode::ByEnum id);
+        void mouseButtonHeld    (MouseButtonCode::ByEnum id);
         void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize);
         void mouseScrolled      (int abs, int rel);
 
-        void joyStickButtonPressed (unsigned int joyStickID, JoyStickButton::Enum id);
-        void joyStickButtonReleased(unsigned int joyStickID, JoyStickButton::Enum id);
-        void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButton::Enum id);
+        void joyStickButtonPressed (unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
+        void joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
+        void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
         void joyStickAxisMoved     (unsigned int joyStickID, unsigned int axis, float value);
 
@@ -83,6 +84,105 @@
         std::vector<JoyStickHandler*> joyStickHandler_;
         JoyStickHandler*              joyStickHandlerAll_;
-        std::vector<InputHandler*>   allHandlers_;
+        std::vector<InputHandler*>    allHandlers_;
     };
+
+    inline void SimpleInputState::tickInput(float dt)
+    {
+        for (unsigned int i = 0; i < allHandlers_.size(); ++i)
+        {
+            allHandlers_[i]->tickInput(dt);
+        }
+    }
+
+    inline void SimpleInputState::tickInput(float dt, unsigned int device)
+    {
+        switch (device)
+        {
+        case InputDevice::Keyboard:
+            if (keyHandler_)
+                keyHandler_->tickKey(dt);
+            break;
+
+        case InputDevice::Mouse:
+            if (mouseHandler_)
+                mouseHandler_->tickMouse(dt);
+            break;
+
+        default: // joy sticks
+            if (joyStickHandler_[device - 2])
+                joyStickHandler_[device - 2]->tickJoyStick(dt, device - 2);
+            break;
+        }
+    }
+
+    inline void SimpleInputState::keyReleased(const KeyEvent& evt)
+    {
+        if (keyHandler_)
+            keyHandler_->keyReleased(evt);
+    }
+
+    inline void SimpleInputState::keyHeld(const KeyEvent& evt)
+    {
+        if (keyHandler_)
+            keyHandler_->keyHeld(evt);
+    }
+
+    inline void SimpleInputState::mouseMoved(IntVector2 abs, IntVector2 rel, IntVector2 clippingSize)
+    {
+        if (mouseHandler_)
+            mouseHandler_->mouseMoved(abs, rel, clippingSize);
+    }
+
+    inline void SimpleInputState::mouseScrolled(int abs, int rel)
+    {
+        if (mouseHandler_)
+            mouseHandler_->mouseScrolled(abs, rel);
+    }
+
+    inline void SimpleInputState::mouseButtonPressed(MouseButtonCode::ByEnum id)
+    {
+        if (mouseHandler_)
+            mouseHandler_->mouseButtonPressed(id);
+    }
+
+    inline void SimpleInputState::mouseButtonReleased(MouseButtonCode::ByEnum id)
+    {
+        if (mouseHandler_)
+            mouseHandler_->mouseButtonReleased(id);
+    }
+
+    inline void SimpleInputState::mouseButtonHeld(MouseButtonCode::ByEnum id)
+    {
+        if (mouseHandler_)
+            mouseHandler_->mouseButtonHeld(id);
+    }
+
+    inline void SimpleInputState::joyStickAxisMoved(unsigned int joyStickID, unsigned int axis, float value)
+    {
+        assert(joyStickID < joyStickHandler_.size());
+        if (joyStickHandler_[joyStickID])
+            joyStickHandler_[joyStickID]->joyStickAxisMoved(joyStickID, axis, value);
+    }
+
+    inline void SimpleInputState::joyStickButtonPressed(unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
+    {
+        assert(joyStickID < joyStickHandler_.size());
+        if (joyStickHandler_[joyStickID])
+            joyStickHandler_[joyStickID]->joyStickButtonPressed(joyStickID, id);
+    }
+
+    inline void SimpleInputState::joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
+    {
+        assert(joyStickID < joyStickHandler_.size());
+        if (joyStickHandler_[joyStickID])
+            joyStickHandler_[joyStickID]->joyStickButtonReleased(joyStickID, id);
+    }
+
+    inline void SimpleInputState::joyStickButtonHeld(unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
+    {
+        assert(joyStickID < joyStickHandler_.size());
+        if (joyStickHandler_[joyStickID])
+            joyStickHandler_[joyStickID]->joyStickButtonHeld(joyStickID, id);
+    }
 }
 
Index: code/trunk/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSGraphics.cc	(revision 1881)
+++ code/trunk/src/orxonox/gamestates/GSGraphics.cc	(revision 1887)
@@ -114,4 +114,5 @@
         // Configure master input state with a KeyBinder
         //masterKeyBinder_ = new KeyBinder();
+        //masterKeyBinder_->loadBindings("master_keybindings.ini");
         //inputManager_->getMasterInputState()->addKeyHandler(masterKeyBinder_);
 
Index: code/trunk/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 1881)
+++ code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 1887)
@@ -36,4 +36,8 @@
 #include "core/input/KeyBinder.h"
 #include "core/Loader.h"
+#include "core/CommandExecutor.h"
+#include "core/ConsoleCommand.h"
+#include "core/ConfigValueIncludes.h"
+#include "core/CoreIncludes.h"
 #include "objects/Backlight.h"
 #include "objects/Tickable.h"
@@ -55,8 +59,15 @@
         , hud_(0)
     {
+        RegisterObject(GSLevel);
+        setConfigValues();
     }
 
     GSLevel::~GSLevel()
     {
+    }
+
+    void GSLevel::setConfigValues()
+    {
+        SetConfigValue(keyDetectorCallbackCode_, "KeybindBindingStringKeyName=");
     }
 
@@ -65,5 +76,5 @@
         inputState_ = InputManager::getInstance().createInputState<SimpleInputState>("game", 20);
         keyBinder_ = new KeyBinder();
-        keyBinder_->loadBindings();
+        keyBinder_->loadBindings("keybindings.ini");
         inputState_->setHandler(keyBinder_);
 
@@ -88,4 +99,14 @@
         // TODO: insert slomo console command with
         // .accessLevel(AccessLevel::Offline).defaultValue(0, 1.0).axisParamIndex(0).isAxisRelative(false);
+
+        // keybind console command
+        FunctorMember<GSLevel>* functor1 = createFunctor(&GSLevel::keybind);
+        functor1->setObject(this);
+        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(functor1, "keybind"));
+        FunctorMember<GSLevel>* functor2 = createFunctor(&GSLevel::tkeybind);
+        functor2->setObject(this);
+        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(functor2, "tkeybind"));
+        // set our console command as callback for the key detector
+        InputManager::getInstance().setKeyDetectorCallback(std::string("keybind ") + keyDetectorCallbackCode_);
     }
 
@@ -145,3 +166,55 @@
         delete this->startLevel_;
     }
+
+    void GSLevel::keybind(const std::string &command)
+    {
+        this->keybindInternal(command, false);
+    }
+
+    void GSLevel::tkeybind(const std::string &command)
+    {
+        this->keybindInternal(command, true);
+    }
+
+    /**
+    @brief
+        Assigns a command string to a key/button/axis. The name is determined via KeyDetector.
+    @param command
+        Command string that can be executed by the CommandExecutor
+        OR: Internal string "KeybindBindingStringKeyName=" used for the second call to identify
+        the key/button/axis that has been activated. This is configured above in enter().
+    */
+    void GSLevel::keybindInternal(const std::string& command, bool bTemporary)
+    {
+        static std::string bindingString = "";
+        static bool bTemporarySaved = false;
+        static bool bound = true;
+        // note: We use a long name to make 'sure' that the user doesn't use it accidentally.
+        // Howerver there will be no real issue if it happens anyway.
+        if (command.find(keyDetectorCallbackCode_) != 0)
+        {
+            if (bound)
+            {
+                COUT(0) << "Press any button/key or move a mouse/joystick axis" << std::endl;
+                InputManager::getInstance().requestEnterState("detector");
+                bindingString = command;
+                bTemporarySaved = bTemporary;
+                bound = false;
+            }
+            //else:  We're still in a keybind command. ignore this call.
+        }
+        else
+        {
+            if (!bound)
+            {
+                // user has pressed the key
+                std::string name = command.substr(this->keyDetectorCallbackCode_.size());
+                COUT(0) << "Binding string \"" << bindingString << "\" on key '" << name << "'" << std::endl;
+                this->keyBinder_->setBinding(bindingString, name, bTemporarySaved);
+                InputManager::getInstance().requestLeaveState("detector");
+                bound = true;
+            }
+            // else: A key was pressed within the same tick, ignore it.
+        }
+    }
 }
Index: code/trunk/src/orxonox/gamestates/GSLevel.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSLevel.h	(revision 1881)
+++ code/trunk/src/orxonox/gamestates/GSLevel.h	(revision 1887)
@@ -37,6 +37,7 @@
 namespace orxonox
 {
-    class _OrxonoxExport GSLevel : public GameState<GSGraphics>
+    class _OrxonoxExport GSLevel : public GameState<GSGraphics>, public OrxonoxClass
     {
+        friend class ClassIdentifier<GSLevel>;
     public:
         GSLevel(const std::string& name);
@@ -58,4 +59,9 @@
         float timeFactor_;       //!< A factor to change the gamespeed
 
+        // console commands
+        void keybind(const std::string& command);
+        void tkeybind(const std::string& command);
+        void keybindInternal(const std::string& command, bool bTemporary);
+
         Ogre::SceneManager*   sceneManager_;
         KeyBinder*            keyBinder_;        //!< tool that loads and manages the input bindings
@@ -64,4 +70,11 @@
         Level*                startLevel_;       //!< current hard coded default level
         Level*                hud_;              //!< 'level' object fo the HUD
+
+        // config values
+        std::string           keyDetectorCallbackCode_;
+        
+    private:
+        void setConfigValues();
+
     };
 }
Index: code/trunk/src/orxonox/gui/GUIManager.cc
===================================================================
--- code/trunk/src/orxonox/gui/GUIManager.cc	(revision 1881)
+++ code/trunk/src/orxonox/gui/GUIManager.cc	(revision 1887)
@@ -279,5 +279,5 @@
     }
 
-    void GUIManager::mouseButtonPressed(MouseButton::Enum id)
+    void GUIManager::mouseButtonPressed(MouseButtonCode::ByEnum id)
     {
         try
@@ -292,5 +292,5 @@
     }
 
-    void GUIManager::mouseButtonReleased(MouseButton::Enum id)
+    void GUIManager::mouseButtonReleased(MouseButtonCode::ByEnum id)
     {
         try
@@ -306,21 +306,21 @@
 
 
-    inline CEGUI::MouseButton GUIManager::convertButton(MouseButton::Enum button)
+    inline CEGUI::MouseButton GUIManager::convertButton(MouseButtonCode::ByEnum button)
     {
         switch (button)
         {
-        case MouseButton::Left:
+        case MouseButtonCode::Left:
             return CEGUI::LeftButton;
 
-        case MouseButton::Right:
+        case MouseButtonCode::Right:
             return CEGUI::RightButton;
 
-        case MouseButton::Middle:
+        case MouseButtonCode::Middle:
             return CEGUI::MiddleButton;
 
-        case MouseButton::Button3:
+        case MouseButtonCode::Button3:
             return CEGUI::X1Button;
 
-        case MouseButton::Button4:
+        case MouseButtonCode::Button4:
             return CEGUI::X2Button;
 
Index: code/trunk/src/orxonox/gui/GUIManager.h
===================================================================
--- code/trunk/src/orxonox/gui/GUIManager.h	(revision 1881)
+++ code/trunk/src/orxonox/gui/GUIManager.h	(revision 1887)
@@ -93,7 +93,7 @@
         { }
 
-        void mouseButtonPressed (MouseButton::Enum id);
-        void mouseButtonReleased(MouseButton::Enum id);
-        void mouseButtonHeld    (MouseButton::Enum id)
+        void mouseButtonPressed (MouseButtonCode::ByEnum id);
+        void mouseButtonReleased(MouseButtonCode::ByEnum id);
+        void mouseButtonHeld    (MouseButtonCode::ByEnum id)
         { }
         void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize)
@@ -123,5 +123,5 @@
         State state_;
 
-        static CEGUI::MouseButton convertButton(MouseButton::Enum button);
+        static CEGUI::MouseButton convertButton(MouseButtonCode::ByEnum button);
 
         static GUIManager*        singletonRef_s;
Index: code/trunk/visual_studio/vc8/core.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/core.vcproj	(revision 1881)
+++ code/trunk/visual_studio/vc8/core.vcproj	(revision 1887)
@@ -330,4 +330,8 @@
 				</File>
 				<File
+					RelativePath="..\..\src\core\input\JoyStickDeviceNumberListener.cc"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\core\input\KeyBinder.cc"
 					>
@@ -460,4 +464,8 @@
 				</File>
 				<File
+					RelativePath="..\..\src\core\input\JoyStickDeviceNumberListener.h"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\core\input\KeyBinder.h"
 					>
